function Radio_Poincare(hObject,eventdata)
%% GUI building
%****************************************************
% vytvori objekty umistene v GUI
% nastavi jejich parametry po spusteni
%****************************************************

thisFcn = figure('Name','Radio_Poincare','pos', [15 100 1000 600],'Menubar','none');
bColor=get(thisFcn,'Color');
handles.radiationAxes = axes('parent',thisFcn,'box','on','pos',[0.05 0.5 0.27 0.45]);
view(130,20);
axis equal;
handles.poincareAxes = axes('parent',thisFcn,'box','on','pos',[0.37 0.5 0.27 0.45]);
view(130,20);
axis equal;
handles.polarisationAxes = axes('parent',thisFcn,'box','on','pos',[0.69 0.5 0.27 0.45]);
axis equal;

handles.frequencyListBox = uicontrol('parent', thisFcn,'Style','listbox','units','norm',...
  'string',{'0 Hz'},'position',[.05 .05 .15 .3], 'Enable', 'off');
handles.frequencyText = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','Frequency','position',[.05 .351 .06 .03]);

handles.viewPoincareAllCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,...
    'string','all state of polar.','position',[.21 .32 .15 .03], 'Enable', 'off');
handles.viewEpCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,...
    'string','Ep view','position',[.21 .28 .15 .03],'Value',true, 'Enable', 'off');
handles.viewEtCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,...
    'string','Et view','position',[.21 .24 .15 .03],'Value',true, 'Enable', 'off');

handles.leftCircViewCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,...
    'string','left cir. pol.','position',[.21 .20 .15 .03], 'Enable', 'off');
handles.rightCircViewCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,...
    'string','right cir. pol.','position',[.21 .16 .15 .03], 'Enable', 'off');
handles.viewLogCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,...
    'string','log view','position',[.21 .12 .15 .03], 'Enable', 'off');

handles.thetaFixCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,'Enable','off',...
    'string','fix theta','position',[.35 .22 .15 .03]);
handles.phiFixCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,'Enable','off',...
    'string','fix phi','position',[.35 .12 .15 .03]);

handles.animOnCheckBox = uicontrol('parent', thisFcn,'Style','checkBox','units','norm',...
    'backgroundColor',bColor,...
    'string','animation ON','position',[.69 .345 .15 .03], 'Enable', 'off');

handles.thetaSlider = uicontrol('parent', thisFcn, 'Style', 'slider', 'Min',0, ...
   'Max', 180, 'Value', 0, 'units', 'normalized', ...
   'Position', [0.35 0.253 0.6 0.032], ...
   'SliderStep', [0.028 0.056], 'Enable', 'off');
handles.phiSlider = uicontrol('parent', thisFcn, 'Style', 'slider', 'Min',0, ...
   'Max', 360, 'Value', 0, 'units', 'normalized', ...
   'Position', [0.35 0.153 0.6 0.032], ...
   'SliderStep', [0.014 0.028], 'Enable', 'off');

handles.thetaTextMin = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','0','position',[.35 .286 .03 .03]);
handles.thetaTextMax = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','180','position',[.91 .286 .04 .03]);
handles.thetaTextValue = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','Theta=0','position',[.6 .286 .1 .03]);

handles.phiTextMin = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','0','position',[.35 .186 .03 .03]);
handles.phiTextMax = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','360','position',[.91 .186 .04 .03]);
handles.phiTextValue = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','Phi=0','position',[.605 .186 .1 .03]);

handles.buttonCalc = uicontrol('parent', thisFcn,'Style','pushbutton','units','norm',...
  'string','Calc','position',[.35 .05 .1 .05], 'Enable', 'off');
handles.buttonLoad = uicontrol('parent', thisFcn,'Style','pushbutton','units','norm',...
  'string','Load data','position',[.85 .05 .1 .05]);

handles.buttonAnim = uicontrol('parent', thisFcn,'Style','pushbutton','units','norm',...
  'string','Start anim.','position',[.78 .325 .08 .05],'Visible','off');

handles.ExText = uicontrol('parent', thisFcn,'Style','edit','units','norm',...
    'backgroundColor',[1 1 1],...
    'string','Ex','position',[.69 .42 .08 .03]);
handles.EyText = uicontrol('parent', thisFcn,'Style','edit','units','norm',...
    'backgroundColor',[1 1 1],...
    'string','Ey','position',[.78 .42 .08 .03]);
handles.phaseText = uicontrol('parent', thisFcn,'Style','edit','units','norm',...
    'backgroundColor',[1 1 1],...    
    'string','phase','position',[.87 .42 .08 .03]);

handles.ExLabel = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','Ex','position',[.69 .385 .03 .03]);
handles.EyLabel = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','Ey','position',[.78 .385 .03 .03]);
handles.phaseLabel = uicontrol('parent', thisFcn,'Style','text','units','norm',...
    'backgroundColor',bColor,...
    'string','phase','position',[.87 .385 .03 .03]);

%% slider listeners
%****************************************************
% pro interaktivni reakce slideru nastavi 
% callbacky volane pri zmene polohy slideru
%****************************************************
handles.sliderThetaListener = addlistener(handles.thetaSlider, ...
        'ContinuousValueChange', @(scr, event) thetaSliderContValCallback(...
                                          handles.thetaSlider));

handles.sliderPhiListener = addlistener(handles.phiSlider, ...
        'ContinuousValueChange', @(scr, event) phiSliderContValCallback(...
                                        handles.phiSlider));

%% callback settings
%****************************************************
% nastavi callbacky jednotlivych objektu GUI
% volane pri jejich pouziti uzivatelem
%****************************************************
set(handles.frequencyListBox,'Callback',@(scr,event)processFreqListBox(handles.frequencyListBox));

set(handles.thetaSlider,'Callback',@(scr,event)editThetaSlider(handles.thetaSlider));
set(handles.phiSlider,'Callback',@(scr,event)editPhiSlider(handles.phiSlider));
set(handles.buttonCalc,'Callback',@(scr,event)processButtonCalc(handles.buttonCalc));
set(handles.buttonLoad,'Callback',@(scr,event)processButtonLoad(handles.buttonLoad));
set(handles.buttonAnim,'Callback',@(scr,event)processAnimButton(handles.buttonAnim));
set(handles.viewPoincareAllCheckBox,'Callback',@(scr,event)processPoincAllChBox(handles.viewPoincareAllCheckBox));
set(handles.thetaFixCheckBox,'Callback',@(scr,event)processThFixChBox(handles.thetaFixCheckBox));
set(handles.phiFixCheckBox,'Callback',@(scr,event)processPhFixChBox(handles.phiFixCheckBox));

set(handles.viewEpCheckBox,'Callback',@(scr,event)processEpChBox(handles.viewEpCheckBox));
set(handles.viewEtCheckBox,'Callback',@(scr,event)processEtChBox(handles.viewEtCheckBox));
set(handles.leftCircViewCheckBox,'Callback',@(scr,event)processLeftCircChBox(handles.leftCircViewCheckBox));
set(handles.rightCircViewCheckBox,'Callback',@(scr,event)processRightCircChBox(handles.rightCircViewCheckBox));

set(handles.viewLogCheckBox,'Callback',@(scr,event)processLogChBox(handles.viewLogCheckBox));
set(handles.animOnCheckBox,'Callback',@(scr,event)plotPolarisationAxes(handles.animOnCheckBox,handles));

guidata(thisFcn, handles);
   
%% sliders continuous lisener function
%****************************************************
% funkce volane callbacky liseneru slideru
% pri interaktivnim tazeni slideru
% zaokrouhluje hodnotu posunu na velikost 
% uhloveho kroku a zobrazi hodnotu v popisce
% prislusneho slideru
%****************************************************
function thetaSliderContValCallback(thisSlider)
    newval = get(thisSlider,'Value');       %get value from the slider
    newval = round(newval);                 %round off this value
 
    thStep = 5;                             %handles.thStep;
    rest = mod(newval,thStep);
      if rest > (thStep/2)                  %rozdeleni posunu na kroky
         newval = newval + (thStep-rest);   %podle poctu kroku uhlu
      else
         newval = newval - rest;
      end
    set(thisSlider, 'Value', newval);
    set(handles.thetaTextValue, 'String', strcat('Theta=',num2str(get(thisSlider, 'Value'))));       
    end

function phiSliderContValCallback(thisSlider)
    newval = get(thisSlider,'Value');       %get value from the slider
    newval = round(newval);                 %round off this value
 
    thStep = 5;                             %handles.phiStep;
    rest = mod(newval,thStep);
      if rest > (thStep/2)                  %rozdeleni posunu na kroky
         newval = newval + (thStep-rest);   %podle poctu kroku uhlu
      else
         newval = newval - rest;
      end
    set(thisSlider, 'Value', newval);
    set(handles.phiTextValue, 'String', strcat('Phi=',num2str(get(thisSlider, 'Value'))));
  end

%% uicontrol lisener function settings
%****************************************************
% funkce volane callbacky jednotlivych objektu v GUI
% pri kliknuti do objektu provede operace funkce
%****************************************************
% Sliders
% zaokrouhluje hodnotu posunu na velikost 
% uhloveho kroku a zobrazi hodnotu v popisce
% prislusneho slideru
%****************************************************
 function editThetaSlider(thisSlider)
    newval = get(thisSlider,'Value');  %get value from the slider
    newval = round(newval);            %round off this value
 
    thStep = 5;%handles.phiStep;
    rest = mod(newval,thStep);
        if rest > (thStep/2) 
            newval = newval + (thStep-rest);
        else
            newval = newval - rest;
        end
    set(thisSlider, 'Value', newval);
    set(handles.thetaTextValue, 'String', strcat('Theta=',num2str(get(thisSlider, 'Value'))));
    processPloting(thisSlider);
 end
    
function editPhiSlider(thisSlider)
    newval = get(thisSlider,'Value');  %get value from the slider
    newval = round(newval);            %round off this value
 
    thStep = 5;%handles.phiStep;
    rest = mod(newval,thStep);
    if rest > (thStep/2) 
       newval = newval + (thStep-rest);
    else
       newval = newval - rest;
    end
    set(thisSlider, 'Value', newval);
    set(handles.phiTextValue, 'String', strcat('Phi=',num2str(get(thisSlider, 'Value'))));
    processPloting(thisSlider);
end
%****************************************************
% Button Load
% otevre dialog pro vyber a nahrani souboru
% provede v souboru vyhledani hodnot jednotlivych
% parametru mereni a ulozi je do promennych
%****************************************************
function processButtonLoad(thisButton)
    handles.buttLoadOldColor = get(handles.buttonLoad, 'backgroundColor');
    set(handles.buttonLoad, 'backgroundColor', [0.8 0.2 0.2]);
    set(handles.buttonLoad, 'Enable', 'off');
        
    [fileName, pathName] = uigetfile({'*.ffs','Far Field Structure (*.ffs)'});
    if isequal(fileName,0)
       set(handles.buttonLoad, 'backgroundColor', handles.buttLoadOldColor);
       set(handles.buttonLoad, 'Enable', 'on');
    return;
    end
    fullNameWithPath = fullfile(pathName, fileName);

%*********** otevreni souboru a hledani signatur  ********
    fid1 = fopen(fullNameWithPath);
    tline = fgetl(fid1);

    set(handles.frequencyListBox, 'Value', 1);
%********* hledani poctu frekvenci *****
    numberFreq=1;
    while ischar(tline)
        k = strfind(tline,'#Frequencies');
        if ~isempty(k)
           break;
        end    
        tline = fgetl(fid1);
    end
    tline = fgetl(fid1);

    numberFreq = str2double(tline);
    freqList = zeros(1,numberFreq);

    tline = fgetl(fid1);
    while ischar(tline)
        k = strfind(tline,'Frequency');
        if ~isempty(k)
           break;
        end    
        tline = fgetl(fid1);
    end

    for i = 1:numberFreq
        tline = fgetl(fid1);
        tline = fgetl(fid1);
        tline = fgetl(fid1);
        tline = fgetl(fid1);
        freqList(i) = str2double(tline);
        tline = fgetl(fid1);
    end

    while ischar(tline)
        k = strfind(tline,'#theta samples');
        if ~isempty(k)
           break;
        end    
        tline = fgetl(fid1);
    end
    tline = fgetl(fid1);

    parts = str2num(tline);
        handles.phiParts = parts(1);
        handles.thetaParts = parts(2);
    guidata(thisFcn, handles);

    for i = 1:numberFreq
    
    fname = strcat('A',num2str(i),'.ffm');
    fid2 = fopen(fname,'w');

        while ischar(tline)
            k = strfind(tline,'Im(E_Phi):');
            if ~isempty(k)
               break;
            end    
        tline = fgetl(fid1);
        end

        while ischar(tline)
            %k = strfind(tline,'');
            if isempty(tline)
               break;
            end
        fprintf(fid2,'%s\n',tline);    
        tline = fgetl(fid1);
        end
    fclose(fid2);

    end
    fclose(fid1);
%**********konec parsingu *************
    freqStr = arrayfun(@num2str, freqList, 'UniformOutput', false);
    set(handles.frequencyListBox, 'String', freqStr);

    phiParts=handles.phiParts;
    thetaParts=handles.thetaParts;

    step1 = (180/(thetaParts-1))/180;
    step2 = 10/180;
    set(handles.thetaSlider, 'Min',0,'Max',180,'SliderStep',[step1 step2]);

    step1 = (360/(phiParts-1))/360;
    step2 = 10/360;
    set(handles.phiSlider, 'Min',0,'Max',360,'SliderStep',[step1 step2]);

    processButtonCalc(thisFcn);
    set(handles.buttonLoad, 'backgroundColor', handles.buttLoadOldColor);
    set(handles.buttonLoad, 'Enable', 'on');
    
    set(handles.thetaSlider, 'Enable', 'on');
    set(handles.phiSlider, 'Enable', 'on');
    
    set(handles.frequencyListBox, 'Enable', 'on');
    set(handles.buttonCalc, 'Enable', 'on');
    set(handles.viewPoincareAllCheckBox, 'Enable', 'on');
    set(handles.viewEpCheckBox, 'Enable', 'on');
    set(handles.viewEtCheckBox, 'Enable', 'on');
    set(handles.leftCircViewCheckBox, 'Enable', 'on');
    set(handles.rightCircViewCheckBox, 'Enable', 'on');
    set(handles.viewLogCheckBox, 'Enable', 'on');
    set(handles.animOnCheckBox, 'Enable', 'on');
    
end
end
%****************************************************
% Button Calc
% spusti vypocty jednotlivych zobrazeni a nastavi 
% vychozi uhel pozorovani jednotlivych ploch
%****************************************************
 function processButtonCalc(hObject)
    handles=guidata(hObject);
    axes(handles.radiationAxes);
    view(130,20);
    axes(handles.poincareAxes);
    view(130,20);
    processPloting(hObject)
 end
%****************************************************
% spusteni vykresleni vsech ploch
%****************************************************
 function processPloting(hObject)
    handles=guidata(hObject);
    plotRadiationAxes(hObject,  handles);
    plotPoincareAxes(hObject,  handles);
    plotPolarisationAxes(hObject,  handles);
 end
%****************************************************
% vykresleni vyzarovaci charakteristiky
%****************************************************
function plotRadiationAxes(hObject,  handles)
axes(handles.radiationAxes);
cla;
handles.edit_Freq_index = get(handles.frequencyListBox, 'Value');

phiParts=handles.phiParts;
thetaParts=handles.thetaParts;

phi    = linspace(0, 360, phiParts); % Toroidal angle
theta  = linspace(0, 180, thetaParts); % Poloidal angle

[p, t] = meshgrid(phi, theta);

delimiterIn = ' ';
headerlinesIn = 1;

i=handles.edit_Freq_index; 
fname = strcat('A',num2str(i),'.ffm');

A = importdata(fname,delimiterIn,headerlinesIn);

thetaRe=zeros(thetaParts,phiParts);
thetaIm=zeros(thetaParts,phiParts);
phiRe=zeros(thetaParts,phiParts);
phiIm=zeros(thetaParts,phiParts);
% naplneni matic/e hodnotami jedne frekvence
aInd=1;
for c= 1:phiParts
for r= 1:thetaParts

thetaRe(r, c) = A.data(aInd,3);
thetaIm(r, c) = A.data(aInd,4);
phiRe(r, c) = A.data(aInd,5); 
phiIm(r, c) = A.data(aInd,6); 

aInd= aInd+1;
end
end

%vypocet uhlu slozek E
%**** funkcni pro vypocet stokes
uhelThe = atan2(thetaIm,thetaRe)/pi*180;
uhelPhi = atan2(phiIm,phiRe)/pi*180;
uhelDiff = uhelThe-uhelPhi; %J

range=(uhelDiff > 180);
uhelDiff(range) = (-360 + uhelDiff(range));
range=(uhelDiff < -180);
uhelDiff(range) = (360 + uhelDiff(range));

%******************************

lrotace = uhelDiff < 0;
rrotace = uhelDiff > 0;

%vypocet radio radiation
th = sqrt(thetaRe.^2 + thetaIm.^2);
ph = sqrt(phiRe.^2 + phiIm.^2);

%**** zobrazeni jen E slozek *****
th2 = 0;
ph2 = 0;
%handles=guidata(hObject);
if (get(handles.viewEpCheckBox,'Value'))
    %th2 = 0;
    ph2 = ph;
end

if (get(handles.viewEtCheckBox,'Value'))
    th2=th;
    %ph2=0;
end

%xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

radio = sqrt(th2.^2 + ph2.^2);

if (get(handles.viewLogCheckBox,'Value'))
radio = 20*log10(radio+1);
end

if (get(handles.leftCircViewCheckBox,'Value'))
radio = radio.*lrotace;
end

if (get(handles.rightCircViewCheckBox,'Value'))
radio = radio.*rrotace;
end

ram=max(abs(radio(:)));
radio=radio/ram;

handles=guidata(hObject);
S0  = ph.^2+th.^2;
handles.S1n = (ph.^2-th.^2)./S0;
handles.S2n = (2*ph.*th.*cosd(uhelDiff))./S0;
handles.S3n = (2*ph.*th.*sind(uhelDiff))./S0;

handles.OM=ph;
handles.ON=th;
handles.uhelDiff=uhelDiff;

guidata(hObject, handles);

%Jednotkova kuloplocha
xvect=sind(t).*cosd(p);
yvect=sind(t).*sind(p);
zvect=cosd(t);

%vyzarovaci charakteristika
xd=radio.*xvect;
yd=radio.*yvect; 
zd=radio.*zvect;

%***** soucet vektoru matic Dipol plus Smycka ******

x=xd;
y=yd;
z=zd;

caxis(caxis);
col=sqrt(x.^2+y.^2+z.^2);
cm=max(abs(col(:)));
if cm>1
col=col/cm;
end

shading interp;
camlight left;
lighting phong;
v = get(gca,'view');

M = surf(x, y, z, col,'LineStyle', 'none', 'FaceColor', 'interp');

set(gca,'view',v);

set(M,'edgecolor',[0 0 0]); %[.2 .4 .9]) %,'FaceColor','none'
set(gca,'fontweight','bold','fontsize',12,'fontname','arial');

hold on;
plotPinPointer(hObject, handles)
hold off;
xlabel('x');
ylabel('y');
zlabel('z');

rotate3d on;
grid on;
axis equal
end
%%
function plotPinPointer(hObject,  handles)
phiParts=handles.phiParts;
thetaParts=handles.thetaParts;

phi    = linspace(0, 360, phiParts); % Toroidal angle
theta  = linspace(0, 180, thetaParts); % Poloidal angle

[p, t] = meshgrid(phi, theta);

uhel_Theta = get(handles.thetaSlider,'Value');
uhel_Phi = get(handles.phiSlider,'Value');

ct = linspace(0,360,37);
cx = cosd(ct);
cy = sind(ct);
cz = 0*ct;
s = sind(90-uhel_Theta);
c = cosd(90-uhel_Theta);
cs = repmat(s,1,37);

%pulkruh polednikove pravitko
pt = linspace(0,180,19);
px = cosd(pt);
py = sind(pt);
ps = sind(uhel_Phi);
pc = cosd(uhel_Phi);

plot3(cx,cy,cz,'-r.'); %rovnik
plot3(cz,cy,cx,'-r.'); %polednik x
plot3(cx,cz,cy,'-r.'); %polednik y

plot3(c*cx,c*cy,cs,'-k'); %rovnobezne pravitko
plot3(pc*py,ps*py,px,'-k'); %polednikove pravitko

%osy vyzarovaku
qOx=quiver3(0,0,0,1.2,0,0,'MaxHeadSize',0.35,'AutoScale','off','LineWidth',2,'Color','r');
qOy=quiver3(0,0,0,0,1.2,0,'MaxHeadSize',0.35,'AutoScale','off','LineWidth',2,'Color','g');
qOz=quiver3(0,0,0,0,0,1.2,'MaxHeadSize',0.35,'AutoScale','off','LineWidth',2,'Color','b');

%spendlik
uhel_Thetas = 90-uhel_Theta;
uhel_Phis = uhel_Phi;

px=1.2 * cosd(uhel_Thetas).*cosd(uhel_Phis); 
py=1.2 * cosd(uhel_Thetas).*sind(uhel_Phis); 
pz=1.2 * sind(uhel_Thetas);

plot3([0 px],[0 py],[0 pz],'Color',[0 0 0],'LineWidth',2);
scatter3(px,py,pz,'LineWidth',2,'MarkerEdgeColor','k',...
        'MarkerFaceColor',[0 .75 .75]);
end

function plotPoincareAxes(hObject,  handles)
%************ vykresleni poincare koule *************
% tato cast je prepracovany kod volne dostupneho
% kodu Mathworks resici tuto problematiku
% kod je dostupny na www.mathworks.com/matlabcentral/fileexchange/
% 10979-poincare-sphere-plot-of-polarimetry-stokes-vectors
axes(handles.poincareAxes);
cla;
phiParts=handles.phiParts;
thetaParts=handles.thetaParts;
phi    = linspace(0, 360, phiParts); % Toroidal angle
theta  = linspace(0, 180, thetaParts); % Poloidal angle
[p, t] = meshgrid(phi, theta);

X=sind(t).*cosd(p);
Y=sind(t).*sind(p);
Z=cosd(t);

v = get(gca,'view');
Hs = mesh(X,Y,Z,'facecolor','w','edgecolor',[0.5 0.5 0.5]);  % set grid facecolor to white
set(gca,'view',v);
caxis([1.0 1.01]);  % set grid to appear like all one color
alpha(0.70);  % set opacity of sphere to 70%
axis equal;  % make the three axes equal so the ellipsoid looks like a sphere
set(gcf,'Renderer','opengl');
hold on;
% Draw x- and y- and z-axes
Hx = plot3([-1.5 1.5], [0 0], [0 0],'k-');
set(Hx,'linewidth',2,'linestyle','-','color','k');

ht_xp = text(1.6,0.1,0.1,'0','fontweight','bold','fontsize',12,'fontname','arial','color','k');

ht_xm = text(-1.6,0.1,0.1,'90','fontweight','bold','fontsize',12,'fontname','arial','color','k');
Hy = plot3([0 0], [-1.5 1.5], [0 0],'k-');
set(Hy,'linewidth',2,'linestyle','-','color','k');

ht_yp = text(0.1,1.6,0,'+ 45','fontweight','bold','fontsize',12,'fontname','arial','color','k');
ht_ym = text(0.1,-1.6,0,'- 45','fontweight','bold','fontsize',12,'fontname','arial','color','k');
Hz = plot3([0 0], [0 0], [-1.5 1.5],'k-');
set(Hz,'linewidth',2,'linestyle','-','color','k');

ht_rcp = text(-0.05,-0.05,1.1,'RCP','fontweight','bold','fontsize',12,'fontname','arial','color','k');
ht_lcp = text(-0.05,-0.05,-1.1,'LCP','fontweight','bold','fontsize',12,'fontname','arial','color','k');

% Draw a bold circle about the equator (2*epsilon = 0)
x_e = (-1:.01:1);
z_e=zeros(length(x_e));
y_e_p=zeros(length(x_e));
y_e_n=zeros(length(x_e));
for i = 1:length(x_e)
z_e(i) = 0;
y_e_p(i) = +sqrt(1 - x_e(i)^2);
y_e_n(i) = -sqrt(1 - x_e(i)^2);
end
He = plot3(x_e,y_e_p,z_e,'k-',x_e,y_e_n,z_e);
set(He,'linewidth',2,'color','k');
% Draw a bold circle about the prime meridian (2*theta = 0, 180)
y_pm = (-1:.01:1);
for i = 1:length(x_e) % !! zmatek v pouzitych polich y_pm vs x_e 
x_pm(i) = 0;
z_pm_p(i) = +sqrt(1 - y_pm(i)^2);
z_pm_n(i) = -sqrt(1 - y_pm(i)^2);
end
Hpm = plot3(x_pm,y_pm,z_pm_p,'k-',x_pm,y_pm,z_pm_n,'k-');
set(Hpm,'linewidth',2,'color','k');

Hsm = plot3(y_pm,x_pm,z_pm_p,'k-',y_pm,x_pm,z_pm_n,'k-');
set(Hsm,'linewidth',2,'color','k');

% pred vykreslenim bodu polarizace vyfiltruje
% pokud je volba zapnuta pouze data z Th nebo Phi
handles=guidata(hObject);
    t = get(handles.thetaSlider,'Value');
    t = (t/5)+1;
    p = get(handles.phiSlider, 'Value');
    p = (p/5)+1;
if (get(handles.viewPoincareAllCheckBox,'Value'))
x=handles.S1n;y=handles.S2n;z=handles.S3n;
if (get(handles.thetaFixCheckBox,'Value'))
     x=handles.S1n(t,:);y=handles.S2n(t,:);z=handles.S3n(t,:);
end
if (get(handles.phiFixCheckBox,'Value'))
    x=handles.S1n(:,p);y=handles.S2n(:,p);z=handles.S3n(:,p);
end
else
    x=handles.S1n(t,p);y=handles.S2n(t,p);z=handles.S3n(t,p);
end
H = plot3(x,y,z,'m.');

set(gca,'fontweight','bold','fontsize',12,'fontname','arial');

color = [253/255 15/255 253/255];
set(H,'markersize',15,'markeredgecolor',color,'markerfacecolor',color,'color',color,'linewidth',0.1);

x=handles.S1n(t,p);y=handles.S2n(t,p);z=handles.S3n(t,p);
    px=1.2*x;py=1.2*y;pz=1.2*z;
plot3([x px],[y py],[z pz],'Color',[0 0 0],'LineWidth',2);
scatter3(px,py,pz,'LineWidth',2,'MarkerEdgeColor','k',...
        'MarkerFaceColor',[0 .75 .75]);
end

function plotPolarisationAxes(hObject,  handles)
handles=guidata(hObject);
if (get(handles.animOnCheckBox,'Value'))
    plotAnimElipse(hObject,  handles);
    set(handles.buttonAnim,'Visible','on');
else
    set(handles.buttonAnim,'Visible','off');
    plotElipse(hObject,  handles);
end
end

function plotAnimElipse(hObject,  handles)
axes(handles.polarisationAxes);

%******* vypocet polarizace v danem bode *****
handles=guidata(hObject);
    t = get(handles.thetaSlider,'Value');
    t = (t/5)+1;
    p = get(handles.phiSlider, 'Value');
    p = (p/5)+1;
%************ elipsa z vektoru Edt a Esp
a=handles.OM(t,p);
b=handles.ON(t,p);
uhelPhase=handles.uhelDiff(t,p);
set(handles.ExText,'String',num2str(a));
set(handles.EyText,'String',num2str(b));
set(handles.phaseText,'String',num2str(uhelPhase));
%***************
omega = linspace(0, 360, 37);%' .* (pi / 180);
y=b*cosd(omega);
x=a*cosd(omega-uhelPhase);

maxlim=1.2*max(max(abs(x)),max(abs(y)));
axis([-maxlim maxlim -maxlim maxlim]);

cla;
hold on;
h=plot(NaN,NaN);
set(gca,'Color',[1 1 1]);
grid on;
plot([-maxlim maxlim],[0 0],':b');
plot([0 0],[-maxlim maxlim],':b');

% vykresleni objektu vektoru
qEx=quiver(0,0,x(1),0,'MaxHeadSize',0.35,'AutoScale','off','LineWidth',2,'Color','r');
qEy=quiver(0,0,0,y(1),'MaxHeadSize',0.35,'AutoScale','off','LineWidth',2,'Color','g');
qE=quiver(0,0,x(1),y(1),'MaxHeadSize',0.35,'AutoScale','off','LineWidth',2,'Color','b');
% vykresleni objektu slozek vektoru
qExt=text(x(1)*1.1,-0.6,'Eph','fontweight','bold','fontsize',12,'fontname','arial','color','r');
qEyt=text(-1,y(1)*1.1,'Eth','fontweight','bold','fontsize',12,'fontname','arial','color','g');
qEt=text(x(1)*1.1,y(1)*1.1,'E','fontweight','bold','fontsize',12,'fontname','arial','color','b');
% x-ova a y-nova pomocna usecka
lEx=plot([0 x(1)],[y(1) y(1)],'--r');
lEy=plot([x(1) x(1)],[0 y(1)],'--g');
% text rotace
if (uhelPhase < 0)
rotText = text(-b,a,'LCP','fontweight','bold','fontsize',12,'fontname','arial','color','k');
else
rotText = text(-b,a,'RCP','fontweight','bold','fontsize',12,'fontname','arial','color','k');
end
hold off;

% vykresleni animovane elipsy a vektoru
for i=1:37
drawnow;
%plot(x(i),y(i),'-b');
pause(0.1);
set(h,'XData',x(1:i),'YData',y(1:i));
set(qE,'UData',x(i),'VData',y(i));
set(qEt,'Position',[(x(i)*1.1) (y(i)*1.1)]);
set(qEx,'UData',x(i));
set(qExt,'Position',[(x(i)*0.8) (-0.6)]);
set(qEy,'VData',y(i));
set(qEyt,'Position',[(-1.5) (y(i)*0.8)]);

set(lEx,'XData', [0 x(i)],'YData', [y(i) y(i)]);
set(lEy,'XData', [x(i) x(i)],'YData', [0 y(i)]);

handles.M(i) = getframe; % zaznam snimku pro animaci
end
guidata(hObject, handles);
grid on;
axis equal;
end
% p?ehrn animace
function processAnimButton(thisButton)
handles=guidata(thisButton);
axes(handles.polarisationAxes);
movie(handles.M,2)
end
% vykresleni neanimovane elipsy
function plotElipse(hObject,  handles)
axes(handles.polarisationAxes);

%******* vypocet polarizace v danem bode *****
handles=guidata(hObject);
    t = get(handles.thetaSlider,'Value');
    t = (t/5)+1;
    p = get(handles.phiSlider, 'Value');
    p = (p/5)+1;

%************ elipsa z vektoru Edt a Esp
a=handles.OM(t,p);
b=handles.ON(t,p);
uhelPhase=handles.uhelDiff(t,p);
set(handles.ExText,'String',num2str(a));
set(handles.EyText,'String',num2str(b));
set(handles.phaseText,'String',num2str(uhelPhase));

omega = linspace(0, 360, 37);%' .* (pi / 180);
y=b*cosd(omega);
x=a*cosd(omega-uhelPhase);

maxlim=1.2*max(max(abs(x)),max(abs(y)));
axis([-maxlim maxlim -maxlim maxlim]);

cla;
hold on;
set(gca,'Color',[1 1 1]);
plot([-maxlim maxlim],[0 0],':b');
plot([0 0],[-maxlim maxlim],':b');

%vykresleni elipsy
plot(x,y,'-b');
if (uhelPhase < 0)
rotText = text(-b,a,'LCP','fontweight','bold','fontsize',12,'fontname','arial','color','k');
else
rotText = text(-b,a,'RCP','fontweight','bold','fontsize',12,'fontname','arial','color','k');
end
hold off;
grid on;
axis equal;
end
% volba vykresleni vsech polarizacnich bodu
function processPoincAllChBox(thisCheckBox)
handles=guidata(thisCheckBox);
if (get(thisCheckBox,'Value'))
    set(handles.thetaFixCheckBox,'Enable','on');
    set(handles.phiFixCheckBox,'Enable','on');
else
    set(handles.thetaFixCheckBox,'Enable','off');
    set(handles.phiFixCheckBox,'Enable','off');
end
processPloting(thisCheckBox);
end
% volba zafixovani Theta
function processThFixChBox(thisCheckBox)
handles=guidata(thisCheckBox);
if (get(thisCheckBox,'Value'))
    set(handles.phiFixCheckBox,'Value',false);
end
processPloting(thisCheckBox);
end
% volba zafixovani Phi
function processPhFixChBox(thisCheckBox)
handles=guidata(thisCheckBox);
if (get(thisCheckBox,'Value'))
    set(handles.thetaFixCheckBox,'Value',false);
end
processPloting(thisCheckBox);
end
% volba zobrazeni levotocive polarizace
function processLeftCircChBox(thisCheckBox)
handles=guidata(thisCheckBox);
if (get(thisCheckBox,'Value'))
    set(handles.rightCircViewCheckBox,'Value',false);
end
processPloting(thisCheckBox);
end
% volba zobrazeni pravotocive polarizace
function processRightCircChBox(thisCheckBox)
handles=guidata(thisCheckBox);
if (get(thisCheckBox,'Value'))
    set(handles.leftCircViewCheckBox,'Value',false);
end
processPloting(thisCheckBox);
end
% vyber frekvence ze seznamu
function processFreqListBox(thisListBox)
processPloting(thisListBox);
end
% vyber zobrazeni slozek Ephi
function processEpChBox(thisCheckBox)
handles=guidata(thisCheckBox);
if (get(thisCheckBox,'Value'))
    
else
    set(handles.viewEtCheckBox,'Value',true);
end
processPloting(thisCheckBox);
end
% vyber zobrazeni slozek Etheta
function processEtChBox(thisCheckBox)
handles=guidata(thisCheckBox);
if (get(thisCheckBox,'Value'))
    
else
    set(handles.viewEpCheckBox,'Value',true);
end
processPloting(thisCheckBox);
end
% vyber logaritmickeho zobrazeni
function processLogChBox(thisCheckBox)
processPloting(thisCheckBox);
end



